## xen 4.19.1

=== xen/Makefile ===
# $(lastword,) for GNU Make older than 3.81
lastword = $(word $(words $(1)),$(1))
this-makefile := $(call lastword,$(MAKEFILE_LIST))

# This is the correct place to edit the build version.
# All other places this is stored (eg. compile.h) should be autogenerated.
export XEN_VERSION       = 4
export XEN_SUBVERSION    = 19
export XEN_EXTRAVERSION ?= .1$(XEN_VENDORVERSION)
export XEN_FULLVERSION   = $(XEN_VERSION).$(XEN_SUBVERSION)$(XEN_EXTRAVERSION)
-include xen-version

export XEN_WHOAMI	?= $(USER)
ifeq ($(origin XEN_DOMAIN), undefined)
export XEN_DOMAIN	:= $(shell ([ -x /bin/dnsdomainname ] && /bin/dnsdomainname) || ([ -x /bin/domainname ] && /bin/domainname || echo [unknown]))
endif
ifeq ($(origin XEN_BUILD_DATE), undefined)
export XEN_BUILD_DATE	:= $(shell LC_ALL=C date)
endif
ifeq ($(origin XEN_BUILD_TIME), undefined)
export XEN_BUILD_TIME	:= $(shell LC_ALL=C date +%T)
endif
ifeq ($(origin XEN_BUILD_HOST), undefined)
export XEN_BUILD_HOST	:= $(shell hostname)
endif

# Best effort attempt to find a python interpreter, defaulting to Python 3 if
# available.  Fall back to just `python`.
PYTHON_INTERPRETER	:= $(word 1,$(shell command -v python3 || command -v python || command -v python2) python)
export PYTHON		?= $(PYTHON_INTERPRETER)

export CHECKPOLICY	?= checkpolicy

$(if $(filter __%, $(MAKECMDGOALS)), \
    $(error targets prefixed with '__' are only for internal use))

# That's our default target when none is given on the command line
PHONY := __all
__all:

# Do not use make's built-in rules and variables
MAKEFLAGS += -rR

EFI_MOUNTPOINT ?= $(BOOT_DIR)/efi

# Allow someone to change their config file
export KCONFIG_CONFIG ?= .config

export TARGET := xen

.PHONY: dist
dist: install

ifneq ($(root-make-done),y)
# section to run before calling Rules.mk, but only once.

ifneq ($(origin crash_debug),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable crash_debug now.")
endif
ifeq ($(origin debug),command line)
$(warning "You must use e.g. 'make menuconfig' to enable/disable debug now.")
endif
ifneq ($(origin frame_pointer),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable frame_pointer now.")
endif
ifneq ($(origin kexec),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable kexec now.")
endif
ifneq ($(origin lock_profile),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable lock_profile now.")
endif
ifneq ($(origin perfc),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable perfc now.")
endif
ifneq ($(origin verbose),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable verbose now.")
endif

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE := $(V)
endif
ifndef KBUILD_VERBOSE
    KBUILD_VERBOSE := 0
endif

ifeq ($(KBUILD_VERBOSE),1)
    quiet :=
    Q :=
else
    quiet := quiet_
    Q := @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(filter-out --%,$(MAKEFLAGS))),)
    quiet := silent_
endif

export quiet Q KBUILD_VERBOSE

# $(realpath,) for GNU Make older than 3.81
realpath = $(wildcard $(foreach file,$(1),$(shell cd -P $(dir $(file)) && echo "$$PWD/$(notdir $(file))")))

ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
endif

ifneq ($(KBUILD_OUTPUT),)
# Make's built-in functions such as $(abspath ...), $(realpath ...) cannot
# expand a shell special character '~'. We use a somewhat tedious way here.
abs_objtree := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) && pwd)
$(if $(abs_objtree),, \
     $(error failed to create output directory "$(KBUILD_OUTPUT)"))

# $(realpath ...) resolves symlinks
abs_objtree := $(call realpath,$(abs_objtree))
else
abs_objtree := $(CURDIR)
endif

ifeq ($(abs_objtree),$(CURDIR))
# Suppress "Entering directory ..." unless we are changing the work directory.
MAKEFLAGS += --no-print-directory
else
need-sub-make := 1
endif

abs_srctree := $(call realpath,$(dir $(this-makefile)))

ifneq ($(words $(subst :, ,$(abs_srctree))), 1)
$(error source directory cannot contain spaces or colons)
endif

ifneq ($(abs_srctree),$(abs_objtree))
# Look for make include files relative to root of kernel src
#
# This does not become effective immediately because MAKEFLAGS is re-parsed
# once after the Makefile is read. We need to invoke sub-make.
MAKEFLAGS += --include-dir=$(abs_srctree)
need-sub-make := 1
endif

export abs_srctree abs_objtree
export root-make-done := y

ifeq ($(need-sub-make),1)

PHONY += $(MAKECMDGOALS) __sub-make

$(filter-out $(this-makefile), $(MAKECMDGOALS)) __all: __sub-make
	@:

# Invoke a second make in the output directory, passing relevant variables
__sub-make:
	$(Q)$(MAKE) -C $(abs_objtree) -f $(abs_srctree)/Makefile $(MAKECMDGOALS)

endif # need-sub-make
endif # root-make-done

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(need-sub-make),)

# Do not print "Entering directory ...",
# but we want to display it when entering to the output directory
# so that IDEs/editors are able to understand relative filenames.
MAKEFLAGS += --no-print-directory

ifeq ($(abs_srctree),$(abs_objtree))
    # building in the source tree
    srctree := .
    building_out_of_srctree :=
else
    ifeq ($(abs_srctree)/,$(dir $(abs_objtree)))
        # building in a subdirectory of the source tree
        srctree := ..
    else
        srctree := $(abs_srctree)
    endif
    building_out_of_srctree := 1
endif

objtree := .
VPATH := $(srctree)

export srctree objtree VPATH

export XEN_ROOT := $(abs_srctree)/..

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to tools/kconfig/Makefile

clean-targets := %clean
no-dot-config-targets := $(clean-targets) \
                         uninstall debug cloc \
                         cscope TAGS tags gtags \
                         xenversion

config-build    := n
need-config     := y

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
        need-config := n
    endif
endif

ifneq ($(filter %config,$(MAKECMDGOALS)),)
    config-build := y
endif

include scripts/Kbuild.include

# Don't break if the build process wasn't called from the top level
# we need XEN_TARGET_ARCH to generate the proper config
include $(XEN_ROOT)/Config.mk

# Set ARCH/SRCARCH appropriately.

ARCH := $(XEN_TARGET_ARCH)
SRCARCH := $(shell echo $(ARCH) | \
    sed -e 's/x86.*/x86/' -e 's/arm\(32\|64\)/arm/g' \
        -e 's/riscv.*/riscv/g' -e 's/ppc.*/ppc/g')
export ARCH SRCARCH

export CONFIG_SHELL := $(SHELL)
export CC CXX LD NM OBJCOPY OBJDUMP ADDR2LINE
export YACC = $(if $(BISON),$(BISON),bison)
export LEX = $(if $(FLEX),$(FLEX),flex)

# Default file for 'make defconfig'.
# May be overruled on the command line or set in the environment.
export KBUILD_DEFCONFIG ?= $(ARCH)_defconfig

# Copy CFLAGS generated by "Config.mk" so they can be reused later without
# reparsing Config.mk by e.g. arch/x86/boot/.
export XEN_TREEWIDE_CFLAGS := $(CFLAGS)

# CLANG_FLAGS needs to be calculated before calling Kconfig
ifneq ($(shell $(CC) --version 2>&1 | head -n 1 | grep clang),)
CLANG_FLAGS :=

ifeq ($(SRCARCH),x86)
# The tests to select whether the integrated assembler is usable need to happen
# before testing any assembler features, or else the result of the tests would
# be stale if the integrated assembler is not used.

# Older clang's built-in assembler doesn't understand .skip with labels:
# https://bugs.llvm.org/show_bug.cgi?id=27369
t1 = $(call as-insn,$(CC),".L0: .L1: .skip (.L1 - .L0)",,-no-integrated-as)

# Check whether clang asm()-s support .include.
t2 = $(call as-insn,$(CC) -I$(srctree)/arch/x86/include,".include \"asm/asm-defns.h\"",,-no-integrated-as)

# Check whether clang keeps .macro-s between asm()-s:
# https://bugs.llvm.org/show_bug.cgi?id=36110
t3 = $(call as-insn,$(CC),".macro FOO;.endm"$(close); asm volatile $(open)".macro FOO;.endm",-no-integrated-as)

CLANG_FLAGS += $(call or,$(t1),$(t2),$(t3))
endif

CLANG_FLAGS += -Werror=unknown-warning-option
CFLAGS += $(CLANG_FLAGS)
export CLANG_FLAGS
endif

export XEN_HAS_CHECKPOLICY := $(call success,$(CHECKPOLICY) -h 2>&1 | grep -q xen)

# ===========================================================================
# Rules shared between *config targets and build targets

PHONY += tools_fixdep
tools_fixdep:
	$(Q)$(MAKE) $(build)=tools tools/fixdep

PHONY += outputmakefile
# Before starting out-of-tree build, make sure the source tree is clean.
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
# At the same time when output Makefile generated, generate .gitignore to
# ignore whole output directory

quiet_cmd_makefile = GEN     Makefile
cmd_makefile = { \
    echo "\# Automatically generated by $(srctree)/Makefile: don't edit"; \
    echo "include $(srctree)/Makefile"; \
    } > Makefile

outputmakefile:
ifdef building_out_of_srctree
	$(Q)if [ -f $(srctree)/.config -o \
		 -d $(srctree)/include/config -o \
		 -d $(srctree)/include/generated ]; then \
		echo >&2 "***"; \
		echo >&2 "*** The source tree is not clean, please run 'make$(if $(findstring command line, $(origin XEN_TARGET_ARCH)), XEN_TARGET_ARCH=$(XEN_TARGET_ARCH)) distclean'"; \
		echo >&2 "*** in $(abs_srctree)";\
		echo >&2 "***"; \
		false; \
	fi
	$(Q)ln -fsn $(srctree) source
	$(call cmd,makefile)
	$(Q)test -e .gitignore || \
	{ echo "# this is build directory, ignore it"; echo "*"; } > .gitignore
endif

ifeq ($(config-build),y)
# ===========================================================================
# *config targets only - make sure prerequisites are updated, and descend
# in tools/kconfig to make the *config target

# Create a file for KCONFIG_ALLCONFIG which depends on the environment.
# This will be use by kconfig targets allyesconfig/allmodconfig/allnoconfig/randconfig
filechk_kconfig_allconfig = \
    $(if $(findstring n,$(XEN_HAS_CHECKPOLICY)), echo 'CONFIG_XSM_FLASK_POLICY=n';) \
    $(if $(KCONFIG_ALLCONFIG), cat $(KCONFIG_ALLCONFIG);) \
    :

.allconfig.tmp: FORCE
	set -e; { $(call filechk_kconfig_allconfig); } > $@

config: tools_fixdep outputmakefile FORCE
	$(Q)$(MAKE) $(build)=tools/kconfig $@

# Config.mk tries to include .config file, don't try to remake it
%/.config: ;

%config: .allconfig.tmp tools_fixdep outputmakefile FORCE
	$(Q)$(MAKE) $(build)=tools/kconfig KCONFIG_ALLCONFIG=$< $@

else # !config-build

ifeq ($(need-config),y)
-include include/config/auto.conf
# Read in dependencies to all Kconfig* files, make sure to run syncconfig if
# changes are detected.
-include include/config/auto.conf.cmd

# Allow people to just run `make` as before and not force them to configure
# Only run defconfig if $(KCONFIG_CONFIG) is missing
$(KCONFIG_CONFIG): tools_fixdep

=== xen/arch/riscv/Makefile ===
obj-$(CONFIG_EARLY_PRINTK) += early_printk.o
obj-y += entry.o
obj-y += mm.o
obj-$(CONFIG_RISCV_64) += riscv64/
obj-y += sbi.o
obj-y += setup.o
obj-y += traps.o
obj-y += vm_event.o

$(TARGET): $(TARGET)-syms
	$(OBJCOPY) -O binary -S $< $@

$(TARGET)-syms: $(objtree)/prelink.o $(obj)/xen.lds
	$(LD) $(XEN_LDFLAGS) -T $(obj)/xen.lds -N $< $(build_id_linker) -o $@
	$(NM) -pa --format=sysv $@ \
		| $(objtree)/tools/symbols --all-symbols --xensyms --sysv --sort \
		> $@.map

$(obj)/xen.lds: $(src)/xen.lds.S FORCE
	$(call if_changed_dep,cpp_lds_S)

.PHONY: include
include:

=== xen/arch/arm/arm64/Makefile ===
obj-y += lib/
obj-$(CONFIG_MMU) += mmu/

obj-y += cache.o
obj-y += cpufeature.o
obj-$(CONFIG_HARDEN_BRANCH_PREDICTOR) += bpi.o
obj-$(CONFIG_EARLY_PRINTK) += debug.o
obj-y += domctl.o
obj-y += domain.o
obj-y += entry.o
obj-y += head.o
obj-y += insn.o
obj-$(CONFIG_LIVEPATCH) += livepatch.o
obj-y += smc.o
obj-y += smpboot.o
obj-$(CONFIG_ARM64_SVE) += sve.o sve-asm.o
obj-y += traps.o
obj-y += vfp.o
obj-y += vsysreg.o

=== xen/arch/ppc/ppc64/Makefile ===
obj-y += exceptions.o
obj-y += exceptions-asm.o
obj-y += head.o
obj-y += opal-calls.o

=== debian/changelog ===
xen (4.19.1-1ubuntu3) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 14:42:57 +0100

xen (4.19.1-1ubuntu2) plucky; urgency=medium

  * Ignore for now -Werror=maybe-uninitialized and -Werror=format-truncation
    errors, probably a better choice w.r.t. using O2 on amd64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 29 Dec 2024 14:46:56 +0100

xen (4.19.1-1) unstable; urgency=medium

  * Upload to unstable (Closes: #1089033)
  * Pick upstream commit e6472d46680c ("tools/xg: increase LZMA_BLOCK_SIZE for
    uncompressing the kernel") to fix decompressing Linux 6.12 when starting
    in PV mode.
  * Note that the following XSA were not listed, because...
    - XSA-465 has patches for the Linux kernel.
    - XSA-466 contains a documentation update that was only applied to the
      current development version of Xen

 -- Hans van Kranenburg <hans@knorrie.org>  Sat, 21 Dec 2024 11:33:16 +0100

xen (4.19.1-1~exp4) experimental; urgency=medium

  * Upload again, with binaries this time.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 21 Dec 2024 11:43:57 +0800

xen (4.19.1-1~exp3) experimental; urgency=medium

  * d/copyright: Fix invalid "-present" copyright years. (Closes: #1089621)

 -- Hans van Kranenburg <hans@knorrie.org>  Fri, 20 Dec 2024 17:00:44 +0100

xen (4.19.1-1~exp2) experimental; urgency=medium

  * Drop support for armhf (Closes: #989560)
    - src:xen now FTBFS on armhf because OCaml 5.x has no support for native
      compilation on 32-bit systems any more.
    - As seen in #989560, Xen on armhf was already dysfunctional for years
    - The team does not have resources or knowledge to support the armhf build

  [ Maximilian Engelhardt ]

  * d/control: Add Maximilian Engelhardt to Uploaders
  * d/copyright: Specify correct years for authors of debian/*
  * debian: undo ABI-stable t64 package renaming

 -- Hans van Kranenburg <hans@knorrie.org>  Mon, 16 Dec 2024 22:01:57 +0100

xen (4.19.1-1~exp1) experimental; urgency=medium

  * Update to new upstream version 4.19.1, which also contains
    security fixes for the following issues:
    - x86: Deadlock in vlapic_error()
      XSA-462 CVE-2024-45817
    - Deadlock in x86 HVM standard VGA handling
      XSA-463 CVE-2024-45818
    - libxl leaks data to PVH guests via ACPI tables
      XSA-464 CVE-2024-45819
  * Fix compilation on arm64 and armhf with upstream commit ee826bc490
    ("Arm64: adjust __irq_to_desc() to fix build with gcc14")

 -- Maximilian Engelhardt <maxi@daemonizer.de>  Sun, 15 Dec 2024 13:52:56 +0100

xen (4.19.0+14-g0918434e0f-1~exp1) experimental; urgency=medium

  Significant changes:
  * Update to new upstream version 4.19.0+14-g0918434e0f, which also contains
    security fixes for the following issues:
    - x86: Register File Data Sampling
      XSA-452 CVE-2023-28746
    - GhostRace: Speculative Race Conditions
      XSA-453 CVE-2024-2193
    - x86 HVM hypercalls may trigger Xen bug check
      XSA-454 CVE-2023-46842
    - x86: Incorrect logic for BTC/SRSO mitigations
      XSA-455 CVE-2024-31142
    - x86: Native Branch History Injection
      XSA-456 CVE-2024-2201
    - double unlock in x86 guest IRQ handling
      XSA-458 CVE-2024-31143
    - error handling in x86 IOMMU identity mapping
      XSA-460 CVE-2024-31145
    - PCI device pass-through with shared resources
      XSA-461 CVE-2024-31146
  * Note that the following XSA are not listed, because...
    - XSA-457 has patches for the Linux kernel.
    - XSA-459 is within Xapi which is not shipped by this package.
  * Fix compilation with OCaml 5.2.0 (Closes: #1073913)

  Changes related to upgrading to Xen 4.19:
  * debian/control: adjust to 4.19
  * debian/copyright: update for xen 4.19
  * Refresh remaining patches if needed

  Packaging minor fixes and improvements:
  * debian/control: remove old version constraints and cleanup
  * debian/control: update Standards-Version to 4.7.0
  * debian/control: add python3-setuptools dependency
  * debian/rules: cleanup and improved comments
  * debian/rules: enable parallel build
  * debian/rules: move xenstore-control to xen-utils-common (Closes: #1036601)
  * debian: ship systemd service files for xen and xendomains
    (Closes: #1029998)
  * docs/Makefile: Work around a reproducibility issue by generating
    documentation for ppc and riscv architectures.

 -- Maximilian Engelhardt <maxi@daemonizer.de>  Mon, 09 Sep 2024 12:05:47 +0200

=== debian/control ===
Source: xen
Priority: optional
Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
Uploaders:
 Ian Jackson <iwj@xenproject.org>,
 Hans van Kranenburg <hans@knorrie.org>,
 Maximilian Engelhardt <maxi@daemonizer.de>,
Section: admin
Standards-Version: 4.7.0
Build-Depends:
   debhelper-compat (= 13),
   dh-exec,
   dpkg-dev (>= 1.22.5),
   file,
   rdfind,
   lsb-release,
   flex, bison,
   python3-dev:any,
   libpython3-dev,
   dh-python,
   python3-setuptools,
   bcc [amd64],
   gcc-multilib [amd64],
   libext2fs-dev,
   iasl,
   seabios [amd64],
   libaio-dev,
   libfdt-dev [arm64],
   libglib2.0-dev,
   liblzma-dev,
   libncurses-dev,
   libpixman-1-dev,
   libyajl-dev,
   pkgconf,
   uuid-dev,
   zlib1g-dev,
   libzstd-dev,
   pandoc,
   ocaml,
   ocaml-findlib,
Homepage: https://xenproject.org/
Vcs-Browser: https://salsa.debian.org/xen-team/debian-xen
Vcs-Git: https://salsa.debian.org/xen-team/debian-xen.git
Rules-Requires-Root: no

Package: xenstore-utils
Architecture: amd64 arm64
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: xen-doc
Description: Xenstore command line utilities for Xen
 This package contains command line utilities for interacting with
 XenStore.
 .
 XenStore is a shared database used for interdomain communication of
 configuration and status information.  It is accessible to all domains
 running on the same Xen host.  See https://wiki.xen.org/wiki/XenStore for
 more information.
 .
 In the common case these tools are used by the Xen toolstack running in
 domain0 (or a driver domain) however they may also be used in a guest
 domain to support local scripting which wants to communicate via XenStore.

Package: xen-utils-common
Section: admin
Architecture: amd64 arm64
Depends: udev, xenstore-utils,
    ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends}
Replaces: xenstore-utils (<< 4.19.0+14-g0918434e0f-1~)
Breaks: xenstore-utils (<< 4.19.0+14-g0918434e0f-1~)
Suggests: xen-doc
Description: Xen administrative tools - common files
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-hypervisor-common
Section: kernel
Architecture: amd64 arm64
Depends: ${misc:Depends}
Description: Xen Hypervisor - common files
 The configuration which arranges for an installed hypervisor to be booted
 as default, with the right command line arguments passed to both
 hypervisor and host (Domain 0) kernel.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-doc
Section: doc
Architecture: amd64 arm64
Depends: ${misc:Depends}
Description: Xen documentation
 Documentation for the Xen hypervisor and surrounding software,
 including descriptions of the hypercall interfaces and of some
 of the library APIs.
 .
 You do not need this package for the primary manpages for the
 Xen control utilities, as those are in the xen-utils-common package.
# Yes, arch-specific.  See xen-doc.lintian-overrides.

Package: xen-utils-4.19
Section: admin
Architecture: amd64 arm64
Provides: xen-utils
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, xen-utils-common (>= ${source:Version})
Recommends: bridge-utils, xen-hypervisor-4.19, qemu-system-xen [amd64], grub-xen-host [amd64]
Suggests: qemu-utils [amd64], seabios [amd64], ovmf
Description: Xen administrative tools
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 qemu-utils and seabios are needed for "Xen HVM" (amd64)
Built-Using: ${misc:Built-Using}

Package: xen-utils-4.19-dbg
Section: debug
Architecture: amd64 arm64
Priority: optional
Depends: xen-utils-4.19 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for xen-utils-4.19
 This package provides debug symbols for the xen-utils binaries as well as
 detached debug symbols for the `shim' used for booting PV guests in an HVM
 container.

Package: xen-hypervisor-4.19-amd64
Section: kernel
Architecture: amd64
Provides: xen-hypervisor, xen-hypervisor-4.19, xen-hypervisor-amd64
Depends: ${misc:Depends}
Recommends: xen-utils-4.19, xen-hypervisor-common
Description: Xen Hypervisor on AMD64
 The hypervisor is the "core" for Xen itself.  It gets started by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.

Package: xen-hypervisor-4.19-amd64-dbg
Section: debug
Architecture: amd64
Priority: optional
Depends: xen-hypervisor-4.19-amd64 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for Xen Hypervisor on AMD64
 This package provides the detached debug symbols for the Xen hypervisor.

Package: xen-system-amd64
Section: admin
Architecture: amd64
Provides: xen-system
Depends: xen-hypervisor-4.19-amd64, xen-hypervisor-common, xen-utils-4.19, ${misc:Depends}
Description: Xen System on AMD64 (metapackage)
 This package depends on the latest Xen hypervisor for use on AMD64 and the
 Xen utils.

Package: xen-hypervisor-4.19-arm64
Section: kernel
Architecture: arm64
Provides: xen-hypervisor, xen-hypervisor-4.19, xen-hypervisor-arm64
Depends: ${misc:Depends}
Recommends: xen-utils-4.19, xen-hypervisor-common
Description: Xen Hypervisor on ARM64
 The hypervisor is the "core" for Xen itself.  It gets started by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.

Package: xen-hypervisor-4.19-arm64-dbg
Section: debug
Architecture: arm64
Priority: optional
Depends: xen-hypervisor-4.19-arm64 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for Xen Hypervisor on ARM64
 This package provides the detached debug symbols for the Xen hypervisor.

Package: xen-system-arm64
Section: admin
Architecture: arm64
Provides: xen-system
Depends: xen-hypervisor-4.19-arm64, xen-hypervisor-common, xen-utils-4.19, ${misc:Depends}
Description: Xen System on ARM64 (metapackage)
 This package depends on the latest Xen hypervisor for use on ARM64 and the
 Xen utils.

Package: libxen-dev
Section: libdevel
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends},
	 libxenmisc4.19 (= ${binary:Version}),
	 libxencall1 (= ${binary:Version}),
	 libxendevicemodel1 (= ${binary:Version}),
	 libxenevtchn1 (= ${binary:Version}),
	 libxenforeignmemory1 (= ${binary:Version}),
	 libxengnttab1 (= ${binary:Version}),
	 libxenstore4 (= ${binary:Version}),
	 libxentoolcore1 (= ${binary:Version}),
	 libxentoollog1 (= ${binary:Version}),
	 libxenhypfs1 (= ${binary:Version}),
Description: Public headers and libs for Xen
 This package contains the public headers and static libraries for Xen.
 .
 The libxenlight library is intended as a common base for all Xen toolstack
 developers.  The libxlutil library contains additional helpers which may
 be useful to toolstack developers.
 .
 The libxenstore library allows userspace processes to interact with
 the XenStore database.  Command line tools for accessing xenstore are
 provided is via the xenstore-utils package.
 .
 Most of the other included libraries are internal, and intended for
 use by the Xen toolstack, rather than directly.

Package: libxenmisc4.19
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - miscellaneous, versioned ABI
 Shared libraries for Xen utilities.
 This package contains libraries whose ABI changes with each
 new upstream Xen release, which include ones which embed
 knowledge of hypervisor-version-specific hypercall ABIs.
Multi-Arch: same

Package: libxencall1
Provides: libxencall1t64 (= ${binary:Version})
Replaces: libxencall1t64
Breaks: libxencall1t64 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime library - libxencall
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxendevicemodel1
Provides: libxendevicemodel1t64 (= ${binary:Version})
Replaces: libxendevicemodel1t64
Breaks: libxendevicemodel1t64 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxendevicemodel
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenevtchn1
Provides: libxenevtchn1t64 (= ${binary:Version})
Replaces: libxenevtchn1t64
Breaks: libxenevtchn1t64 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenevtchn
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenforeignmemory1
Provides: libxenforeignmemory1t64 (= ${binary:Version})
Replaces: libxenforeignmemory1t64
Breaks: libxenforeignmemory1t64 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenforeignmemory
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxengnttab1
Provides: libxengnttab1t64 (= ${binary:Version})
Replaces: libxengnttab1t64
Breaks: libxengnttab1t64 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxengnttab
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenstore4
Provides: libxenstore4t64 (= ${binary:Version})
Replaces: libxenstore4t64
Breaks: libxenstore4t64 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenstore
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxentoolcore1
Provides: libxentoolcore1t64 (= ${binary:Version})
Replaces: libxentoolcore1t64
Breaks: libxentoolcore1t64 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxentoolcore
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxentoollog1
Provides: libxentoollog1t64 (= ${binary:Version})
Replaces: libxentoollog1t64
Breaks: libxentoollog1t64 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxentoollog
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenhypfs1
Provides: libxenhypfs1t64 (= ${binary:Version})
Replaces: libxenhypfs1t64
Breaks: libxenhypfs1t64 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime library - libxenhypfs
 Shared library for Xen utilities.
Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SHELL    := bash -e

# support parallel build
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

# This gives us DEB_VERSION_UPSTREAM and DEB_VERSION (used by our delta queue)
include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION

# DEB_MAINTAINER is used by our delta queue
export DEB_MAINTAINER := $(shell sed -ne 's/^Maintainer: \(.*\)$$/\1/p' debian/control)

# This influences dpkg-buildflags to specify better linker
# options.  See https://wiki.debian.org/Hardening
# Apparently some of these might incur silent breakage
#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=939560#5
# but we don't think this is relevant to us.
#
# Note that we don't use the dpkg-buildflags output for the
# hypervisor build.  This because I haven't investigated which
# of them are sane to use in the hypervisor context, rather than
# simply in userland binaries.
#
# Inexplicably, if you tell make `export V=value' and `$(shell ...)'
# it does not pass V to the shell.  WTF.  So we set a variable
# dbmo which we include in the relevant $(shell ...) invocations.
dbmo= DEB_BUILD_MAINT_OPTIONS="hardening=+all"

# Architecture handling.
#
# We need to explicitly specify the architecture because the Xen
# upstream build system likes to use `uname' which can produce wrong
# answers in other-bitness chroots.

# Also there is terminological confusion.  The DEB_* variables follow
# GNU GCC terminology:
#
# dpkg / GNU    Xen         Meaning
#  BUILD         COMPILE     Host: where this build is running
#  HOST          TARGET      Target: where the binaries we build now will run

include /usr/share/dpkg/architecture.mk

# Xen has its own different architecture names, which are nither
# Debian nor GNU names.

flavour_amd64 = amd64
flavour_arm64 = arm64

xen_arch_amd64 = x86_64
xen_arch_arm64 = arm64

flavour=$(flavour_$(DEB_HOST_ARCH))

# Much of the work here is to make different upstream versions of Xen
# coinstallable, and arrange to run which ever version of the tools
# corresponds to the running hypervisor.
#
# This packaging produces one version.  The nominal upstream version
# represents the control ABI used by hypervisor management utilities.
#
# In this package that version number appears in (i) debian/control
# and (ii) the first two numbers in the package version in
# debian/changelog.  These must both be updated when a new major
# upstream version is packaged (eg 4.10 -> 4.11).
# (Everywhere else, it is handled dynamically.)
#
upstream_version := \
 $(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/\(\.[0-9]*\)\..*/\1/' )

# Many of the debhelper files are most conveniently provided as
# templates which depend on the flavour and the upstream version.
# Since even some package names depend on the version, so do some
# dh input filenames.  We support this as follows:
#
# These runes take all files named   debian/*.vsn-in
# and do these three things:
#  1. in the file contents
#    (a) substitute @version@ @flavour@
#    (b) interpret lines like
#		? flavour = <value> [ | <other-value> ...]
#		? flavour != <value> [ | <other-value> ...]
#     as conditional output lasting until the next ? on is own.
#  2. replace any V in the file *name* with that same version
#     and any F with the flavour
#  3. strip .vsn-in from the end
# The resulting files are then consumed by dh.
#
# (debhelper has a shell script control file facility, but that cannot
# handle the need to vary the actual filename seen by debhelper.)

TEMPLATE_FILES := $(wildcard debian/*.vsn-in)

define template_rule_template =
 TEMPLATED_FILES += $(2)
 $(2): $(1) debian/rules debian/changelog debian/template-subst
	debian/template-subst $(upstream_version) $(flavour) <$$< >$$@.tmp \
	&& mv -f $$@{.tmp,}
endef

$(foreach t,$(TEMPLATE_FILES), $(eval 					\
	$(call 								\
		template_rule_template, $t, 				\
		$(subst F,$(flavour),					\
		 $(subst V,$(upstream_version),				\
		  $(basename $t)					\
		 ))							\
	)))

templated-files: $(TEMPLATED_FILES)
	:

# Work around bug in dpkg-buildpackage: between dpkg 1.14.17 and 1.16.1
# it exports these.  This is a problem because we need to pass different
# options to the hypervisor build - the default options from dpkg
# et al are suitable for dom0 binaries but not for the hypervisor.
# This is still needed post bookworm.
undefine CFLAGS
undefine CXXFLAGS
undefine FFLAGS
undefine CPPFLAGS
undefine LDFLAGS

# The Xen build system likes to download things at build-time.  We
# think we have disabled all of that with appropriate configure
# options.  But, set these too, so we spot if we miss any.
export WGET=/bin/false GIT=/bin/false

# Other build flags etc.

t=$(CURDIR)/debian/tmp

dpkg_CFLAGS   := $(shell $(dbmo) dpkg-buildflags --get CFLAGS)
dpkg_CPPFLAGS := $(shell $(dbmo) dpkg-buildflags --get CPPFLAGS)
dpkg_LDFLAGS  := $(shell $(dbmo) dpkg-buildflags --get LDFLAGS)

make_args_common := \
	CC=$(DEB_HOST_GNU_TYPE)-gcc \
	LD=$(DEB_HOST_GNU_TYPE)-ld \
	XEN_COMPILE_ARCH=$(xen_arch_$(DEB_BUILD_ARCH)) \
	V=1

# Passing -ffile-prefix-map is needed for reproducible builds.
# Additionally passing -fdebug-prefix-map in necessary to work around a gcc bug
# where -ffile-prefix-map is ignored with assembly files. See
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=93371
# This should be fixed with gcc-13, i.e. trixie onwards
make_args_xen := $(make_args_common) \
	XEN_TARGET_ARCH=$(xen_arch_$(flavour)) \
	EXTRA_CFLAGS_XEN_CORE='-ffile-prefix-map=$(shell pwd)=. -fdebug-prefix-map=$(shell pwd)=.'

# (Xen upstream does not offer a separate CPPFLAGS,
# so we pass those in CFLAGS.)
# The BUILD_PATH_PREFIX_MAP is needed for ocaml to reproducibly build
# oxenstored
make_args_tools := $(make_args_common) \
	XEN_TARGET_ARCH=$(xen_arch_$(DEB_HOST_ARCH)) \
	EXTRA_CFLAGS_XEN_TOOLS='$(dpkg_CFLAGS) $(dpkg_CPPFLAGS) -Wno-error=maybe-uninitialized -Wno-error=format-truncation' \
	PREPEND_LDFLAGS_XEN_TOOLS='$(dpkg_LDFLAGS)' \
	BUILD_PATH_PREFIX_MAP='.=$(shell pwd)'

# use the date from SOURCE_DATE_EPOCH for reproducible builds
export XEN_BUILD_DATE=$(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)")
export XEN_BUILD_TIME=$(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)" "+%T")
export SMBIOS_REL_DATE=$(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)" "+%m/%d/%Y")
export VGABIOS_REL_DATE=$(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)" "+%d %b %Y")


%:
	dh $@ --with=python3

# To avoid that the build dirties the tree, our delta queue deletes
# config.sub and config.guess.  dh_update_autotools_config can get
# us fresh ones for each build, but it expects to find some there
# already with some weird properties.  Instead, just copy them
# from /usr/share/misc (which is where it gets them anyway)
override_dh_update_autotools_config:
	cp /usr/share/misc/{config.sub,config.guess} .

# Upstream has both a kconfig style configure for the hypervisor
# and autoconfery for the tools (what we call the `utils').
override_dh_auto_configure:
	cp debian/xen-kconfig xen/.config
	make -C xen olddefconfig $(make_args_xen)
	:
	$(make_args_tools) ./configure \
		--disable-stubdom \
		--prefix=/usr \
		--includedir=/usr/include \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-libexec-libdir-suffix=/$(DEB_HOST_MULTIARCH) \
		--host=$(DEB_HOST_MULTIARCH) \
		--mandir=/usr/share/man \
		--infodir=/usr/share/info \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--with-libexec-leaf-dir=xen-$(upstream_version) \
		--disable-blktap1 \
		--disable-blktap2 \
		--disable-qemu-traditional --disable-rombios \
		--with-system-qemu=/usr/libexec/xen-qemu-system-i386 \
		--enable-ovmf --with-system-ovmf=/usr/share/ovmf/OVMF.fd \
		--with-system-seabios=/usr/share/seabios/bios-256k.bin

# tools/firmware/xen-dir is the `shim' used for booting PV guests
# in an HVM container, for security (particularly, for meltdown/spectre
